/*
 * Harbor API
 * These APIs provide services for manipulating Harbor project.
 *
 * OpenAPI spec version: 2.0
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.4.19
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ComponentHealthStatus'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ComponentHealthStatus'));
  } else {
    // Browser globals (root is window)
    if (!root.HarborApi) {
      root.HarborApi = {};
    }
    root.HarborApi.OverallHealthStatus = factory(root.HarborApi.ApiClient, root.HarborApi.ComponentHealthStatus);
  }
}(this, function(ApiClient, ComponentHealthStatus) {
  'use strict';

  /**
   * The OverallHealthStatus model module.
   * @module model/OverallHealthStatus
   * @version 2.0
   */

  /**
   * Constructs a new <code>OverallHealthStatus</code>.
   * The system health status
   * @alias module:model/OverallHealthStatus
   * @class
   */
  var exports = function() {
  };

  /**
   * Constructs a <code>OverallHealthStatus</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/OverallHealthStatus} obj Optional instance to populate.
   * @return {module:model/OverallHealthStatus} The populated <code>OverallHealthStatus</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();
      if (data.hasOwnProperty('status'))
        obj.status = ApiClient.convertToType(data['status'], 'String');
      if (data.hasOwnProperty('components'))
        obj.components = ApiClient.convertToType(data['components'], [ComponentHealthStatus]);
    }
    return obj;
  }

  /**
   * The overall health status. It is \"healthy\" only when all the components' status are \"healthy\"
   * @member {String} status
   */
  exports.prototype.status = undefined;

  /**
   * @member {Array.<module:model/ComponentHealthStatus>} components
   */
  exports.prototype.components = undefined;


  return exports;

}));
